unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  JumboDialog, StdCtrls, ComCtrls, ToolWin, Buttons, UnfloldButton,
  ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    JumboDialog1: TJumboDialog;
    Panel1: TPanel;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
  	pal : PPalette;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
    if JumboDialog1.Execute then begin
    	//copy selected palette to pal
        //memory allocated if necessary
		pal := JumboDialog1.DupResult( pal,JumboDialog1.PaletteSize,true );
        //and repaint the form
		InvalidateRect( Self.Handle,nil,false );
    end;
end;



procedure TForm1.ToolButton1Click(Sender: TObject);
var
	l : TListItem;
    i : integer;
begin
	JumboDialog1.ActivateToolOptions( panel1,'Sample options' );
    panel1.Caption := 'user tool 1 options';

	if JumboDialog1.PalList.Items.Count > 0 then
    JumboDialog1.PalList.Items[0].Checked := True;

{	l := JumboDialog1.PalList.Items.Insert( 0 );
    p := l.Data;
    for i := 0 to JumboDialog1.PaletteSize-1 do
    	p[i] := RGB( i mod 256,0,0 );
}
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
var i,j : integer;
	p : PPalette;
    lv : TListView;
begin
	JumboDialog1.ActivateToolOptions( panel1,'Sample options' );
    panel1.Caption := 'RED MASK';

	lv := JumboDialog1.PalList;
	for i := 0 to lv.Items.Count-1 do
    	if lv.Items[i].Selected then begin
    		p := lv.Items[i].Data;
            for j := 0 to JumboDialog1.PaletteSize-1 do
            	p[j] := p[j] and $FF0000;
            lv.Items[i].Checked := True;
    	end;
end;

procedure TForm1.ToolButton3Click(Sender: TObject);
var i,j : integer;
	p : PPalette;
    lv : TListView;
begin
(*
	lv := JumboDialog1.PalList;
	for i := 0 to lv.Items.Count-1 do
    	if lv.Items[i].Selected then begin
    		p := lv.Items[i].Data;
            for j := 0 to JumboDialog1.PaletteSize-1 do
            	p[j] := p[j] and $FF00;
            lv.Items[i].Checked := True;
    	end;
*)        
end;

procedure TForm1.Button2Click(Sender: TObject);
var pal : PPalette; //pointer to array of colors [0..X]
	i : integer;
begin
	JumboDialog1.Execute; //executing dialog
    if JumboDialog1.UserOK then begin  //choice confirmed?
    	pal := JumboDialog1.ResultPal; //pointer to palette
        for i := 0 to JumboDialog1.PaletteSize-1 do //go through all colors
        with Image1.Picture.Bitmap.Canvas do begin
        	Pen.Color := _rgbflip( pal[i] ); // draw i-th color by line
            MoveTo( i,0 );
            LineTo( i,Image1.Height );
        end;
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    Image1.Width := JumboDialog1.PaletteSize;
	Image1.Picture.Bitmap.PixelFormat := pf32bit;
    Image1.Picture.Bitmap.Height := image1.Height;
    Image1.Picture.Bitmap.Width := JumboDialog1.PaletteSize;
end;

procedure TForm1.FormPaint(Sender: TObject);
var p : PPalette;
	i : integer;
begin
	if not JumboDialog1.UserOK then exit; //req repaint?
    p := JumboDialog1.DupPalette( pal,nil,Form1.Width,false );
    //scale palette to be equal to form
    for i := 0 to form1.Width-1 do with form1.Canvas do begin
       	Pen.Color := p[i];
        MoveTo( i,0 );
        LineTo( i,form1.Height-1 );
    end;
    FreeMem( p ); //free allocated temp pal pointer
end;

procedure TForm1.FormResize(Sender: TObject);
begin
	InvalidateRect( Self.Handle,nil,false );
end;

end.
